////////////////////////////////////////////////////
// bild1 wird bei jedem Druck auf die Enter-Taste mit der Henon-Vorschrift abgebildet
//mit der Henon-Vorschrift abgebildet
////////////////////////////////////////////////////
 PImage bild1,neuesBild,screen;
 int w, h, xK, yK, nummer;
 float xAlt,yAlt,xNeu,yNeu;
 float alpha = 1.4;
 float beta = 0.3;
 color farbe;
 boolean bildGeaendert;
 float xU =-1; float xO =1.5;
 float yU = -0.5; float yO = 0.5;
//////////////////////////////////////////////////  
void setup() {
 nummer =1;
 bild1 = loadImage("bild1.jpg");  
 neuesBild = loadImage("neuesBild.jpg"); 
 screen = bild1;
 bildGeaendert = false;
 w = bild1.width;  h = bild1.height;
 surface.setSize(w,h);  
 background(255);
 
}
//////////////////////////////////////////////////////////////////////////
void draw(){
  
  image(screen,0,0);
  if(bildGeaendert){
    nummer++;
    save("data/bild"+nummer+".jpg");
    bildGeaendert = false;
  }
   
 
}
////////////////////////////////////////////////////////////////////////
void keyPressed(){
  //Henon Abbildung durchführen
  if (key == ENTER){
  screen= henonDurchfuehren( bild1);
  bildGeaendert = true;  
  }
}
  
//////////////////////////////////////////////////////////////////////////
PImage henonDurchfuehren(PImage bild1){
  bild1 = loadImage("bild"+nummer+".jpg");  
  //über alle Pixel iterieren
  for (int j = 0; j < h; j++) {
   for (int i = 0; i < w; i++) {  
     farbe = bild1.get(i,j);
     //Pixelkoordinaten in Punkte der Ebene verwandeln
     xAlt= map(i,0,w,xU,xO);
     yAlt= map(j,0,h,0.5,-0.5);
     //Henon-Abbildung auf Ebenenpunkt anwenden
     xNeu = yAlt+1-alpha*xAlt*xAlt;
     yNeu = beta*xAlt;
     //Ebenenkoordinaten in Bildschirm Pixel verwandeln
     xK = round( map(xNeu,xU-1.5,xO,0,w));                                     
     yK = round (map(yNeu,yU,yO,h,0));                                           
     neuesBild.set(xK,yK,farbe);    
   }
 } 
  screen = neuesBild;
  return neuesBild;
}